/*
  Copyright (c) 2004,   Beijing Senselock Data Security Centre
  All rights reserved.
  
  File£ºsample_20_hw.c
  
  Briefs£ºThis code will 
    
*/

#include <string.h>
#include "..\..\inc\hardware\ses_v3.h"
#include "..\inc\sample_20.h"

#define _DEBUG

/* global variable defination. */
unsigned char last_ses_error = 0; /* last SES error */
IO_PACKAGE out_pkg;  /* output package */
IO_PACKAGE *output = &out_pkg; 
IO_PACKAGE *input = (IO_PACKAGE *)pbInBuff; /* input package */

/*
	Exit upon an error.
  
	Parameters:
		errcode[in]: error code
		msg[in]: additional error message
		msglen[in]: message length
  
	Return:
		none.

	Remarks:
		none.
*/
void error_exit(unsigned char errcode, unsigned char *msg, int msglen)
{
	output->tag = errcode;
	output->len = 0;
	
	/* for debug purpose only */
#ifdef  _DEBUG
	if (msglen != 0 && msg != NULL)
	{
		memcpy(output->buff, msg, msglen);
		output->len = msglen;
	}
#endif

	_set_response(2+output->len, (unsigned char *)output);
	_exit();
}

void main()
{
	unsigned char ret = 0;
	int length = 0;
	int i = 0;
	float result = 0;
	float tmp = 0;
	DATA_BLOCK *dblk = (DATA_BLOCK *)&input->buff;
	LE16_TO_CC(&dblk->times);	
	LE32_TO_CC(&dblk->op1);
	LE32_TO_CC(&dblk->op2);

	for (; i<dblk->times; i++)
	{
		tmp = _multf(dblk->op1, dblk->op2); 		 
		result = _addf(tmp, result);
//		tmp = (dblk->op1)*(dblk->op2);
//		result += tmp;
	}		
	length = sizeof(result);
	CC_TO_LE32(&result);

	ret = _mem_copy(&output->buff, &result, length);
	if (ret != SES_SUCCESS)
	{
		error_exit(ERR_SES, &ret, sizeof(ret));
	}

	output->tag = ERR_SUCCESS;
	output->len = (unsigned char)length;	
	_set_response(IO_PACKAGE_HEADER_SIZE+output->len, (unsigned char *)output);
	_exit();  
}
